function update_entries() {
    const can_see_assignees = has_permission("auth.view_user");

    function is_assigned_to_user_renderer (data) {
        return (
            data
            && data.lexical_units
            && data.lexical_units.some(lu => lu.assignee_username === window.USER_USERNAME && lu.status == 'O')
        ) ? gettext("tak") : gettext("nie");
    }

    var datatable = setup_datatable({
        url: '/' + lang + '/entries/get_entries/?with_lexical_units=true',
        columns: [
            { data: 'lemma' },
            { data: 'POS' },
            can_see_assignees ? { data: 'assignee_username' } : { render: is_assigned_to_user_renderer },
        ]
    });
    datatable.on('click', 'tr.entry', function () {
        var row = datatable.row(this);
        var has_drilldown = row.child.isShown();
        $('.drilldown:visible').each(function () { datatable.row($(this).data("row")).child.hide(); });
        if (!has_drilldown) {
            if (!row.data()) return;
            var drilldown = $("<div>").addClass("drilldown").data("row", this);
            row.child(drilldown).show();
            // tutaj zmiana na liste zunifikowanych ram
            setup_lexical_units_table(drilldown, row.data().lexical_units, can_see_assignees);
            drilldown.closest("td").addClass("p-0 pl-4");
        }
    });
}

function setup_lexical_units_table(drilldown, lexical_units, can_see_assignees) {
    if (!lexical_units.length) {
        return '';
    }

    function get_lexical_unit_row(lexical_unit) {
        const is_assigned_to_user = lexical_unit.assignee_username === window.USER_USERNAME;
        return $(`
            <tr class="lexical-unit">
                <td class="p-1">${lexical_unit.display}</td>
                <td class="p-1">${lexical_unit.status}</td>
                ` + (
                    can_see_assignees
                        ? `<td class="p-1">${lexical_unit.assignee_username || ""}</td>`
                        : `<td class="p-1">${is_assigned_to_user ? gettext("tak") : gettext("nie")}</td>`
                ) + `
            </tr>
        `).click(function () {
            $(this).addClass('table-primary').siblings().removeClass("table-primary");
            get_entry($(drilldown.data("row")).data("entry"), false);  // TODO replace with loading LU details view
        });
    }
    var table = $(`
        <table class="table">
            <thead>
                <tr>
                    <th class="p-1">${gettext("Jednostka Leksykalna")}</th>
                    <th class="p-1">${gettext("Status")}</th>
                    ` + (
                        can_see_assignees
                            ? `<th class="p-1">${gettext("Leksykograf")}</th>`
                            : `<th class="p-1">${gettext("Moje")}</th>`
                    ) + `
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    `);
    drilldown.append(table);
    lexical_units.map(function (lexical_unit) {
        $("tbody", table).append(get_lexical_unit_row(lexical_unit));
    });
}
